/* ActionManager.c generated by valac 0.54.8, the Vala compiler
 * generated from ActionManager.vala, do not modify */

/*
 * Copyright (c) 2020 Andrew Vojak (https://avojak.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Andrew Vojak <andrew.vojak@gmail.com>
 */

#include <glib-object.h>
#include <gtk/gtk.h>
#include <handy.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>

#define WARBLE_ACTION_MANAGER_ACTION_PREFIX "win."
#define WARBLE_ACTION_MANAGER_ACTION_NEW_GAME "action_new_game"
#define WARBLE_ACTION_MANAGER_ACTION_HELP "action_help"
#define WARBLE_ACTION_MANAGER_ACTION_QUIT "action_quit"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define WARBLE_TYPE_ACTION_MANAGER (warble_action_manager_get_type ())
#define WARBLE_ACTION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), WARBLE_TYPE_ACTION_MANAGER, WarbleActionManager))
#define WARBLE_ACTION_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), WARBLE_TYPE_ACTION_MANAGER, WarbleActionManagerClass))
#define WARBLE_IS_ACTION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WARBLE_TYPE_ACTION_MANAGER))
#define WARBLE_IS_ACTION_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WARBLE_TYPE_ACTION_MANAGER))
#define WARBLE_ACTION_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), WARBLE_TYPE_ACTION_MANAGER, WarbleActionManagerClass))

typedef struct _WarbleActionManager WarbleActionManager;
typedef struct _WarbleActionManagerClass WarbleActionManagerClass;
typedef struct _WarbleActionManagerPrivate WarbleActionManagerPrivate;

#define WARBLE_TYPE_APPLICATION (warble_application_get_type ())
#define WARBLE_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), WARBLE_TYPE_APPLICATION, WarbleApplication))
#define WARBLE_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), WARBLE_TYPE_APPLICATION, WarbleApplicationClass))
#define WARBLE_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WARBLE_TYPE_APPLICATION))
#define WARBLE_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WARBLE_TYPE_APPLICATION))
#define WARBLE_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), WARBLE_TYPE_APPLICATION, WarbleApplicationClass))

typedef struct _WarbleApplication WarbleApplication;
typedef struct _WarbleApplicationClass WarbleApplicationClass;

#define WARBLE_TYPE_MAIN_WINDOW (warble_main_window_get_type ())
#define WARBLE_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), WARBLE_TYPE_MAIN_WINDOW, WarbleMainWindow))
#define WARBLE_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), WARBLE_TYPE_MAIN_WINDOW, WarbleMainWindowClass))
#define WARBLE_IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WARBLE_TYPE_MAIN_WINDOW))
#define WARBLE_IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WARBLE_TYPE_MAIN_WINDOW))
#define WARBLE_MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), WARBLE_TYPE_MAIN_WINDOW, WarbleMainWindowClass))

typedef struct _WarbleMainWindow WarbleMainWindow;
typedef struct _WarbleMainWindowClass WarbleMainWindowClass;
enum  {
	WARBLE_ACTION_MANAGER_0_PROPERTY,
	WARBLE_ACTION_MANAGER_APPLICATION_PROPERTY,
	WARBLE_ACTION_MANAGER_WINDOW_PROPERTY,
	WARBLE_ACTION_MANAGER_NUM_PROPERTIES
};
static GParamSpec* warble_action_manager_properties[WARBLE_ACTION_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _WarbleActionManager {
	GObject parent_instance;
	WarbleActionManagerPrivate * priv;
};

struct _WarbleActionManagerClass {
	GObjectClass parent_class;
};

struct _WarbleActionManagerPrivate {
	WarbleApplication* _application;
	WarbleMainWindow* _window;
	GSimpleActionGroup* action_group;
};

static gint WarbleActionManager_private_offset;
static gpointer warble_action_manager_parent_class = NULL;
static GeeMultiMap* warble_action_manager_accelerators;
static GeeMultiMap* warble_action_manager_accelerators = NULL;

VALA_EXTERN GType warble_action_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WarbleActionManager, g_object_unref)
VALA_EXTERN GType warble_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WarbleApplication, g_object_unref)
VALA_EXTERN GType warble_main_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WarbleMainWindow, g_object_unref)
static void warble_action_manager_action_new_game (WarbleActionManager* self);
static void _warble_action_manager_action_new_game_gsimple_action_activate_callback (GSimpleAction* action,
                                                                              GVariant* parameter,
                                                                              gpointer self);
static void warble_action_manager_action_help (WarbleActionManager* self);
static void _warble_action_manager_action_help_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self);
static void warble_action_manager_action_quit (WarbleActionManager* self);
static void _warble_action_manager_action_quit_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self);
VALA_EXTERN WarbleActionManager* warble_action_manager_new (WarbleApplication* application,
                                                WarbleMainWindow* window);
VALA_EXTERN WarbleActionManager* warble_action_manager_construct (GType object_type,
                                                      WarbleApplication* application,
                                                      WarbleMainWindow* window);
VALA_EXTERN void warble_action_manager_action_from_group (const gchar* action_name,
                                              GActionGroup* action_group,
                                              GVariant* parameter);
VALA_EXTERN WarbleMainWindow* warble_action_manager_get_window (WarbleActionManager* self);
VALA_EXTERN void warble_main_window_new_game (WarbleMainWindow* self);
VALA_EXTERN void warble_main_window_show_rules (WarbleMainWindow* self);
VALA_EXTERN gboolean warble_main_window_before_destroy (WarbleMainWindow* self);
VALA_EXTERN WarbleApplication* warble_action_manager_get_application (WarbleActionManager* self);
static void warble_action_manager_set_application (WarbleActionManager* self,
                                            WarbleApplication* value);
static void warble_action_manager_set_window (WarbleActionManager* self,
                                       WarbleMainWindow* value);
static GObject * warble_action_manager_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void warble_action_manager_finalize (GObject * obj);
static GType warble_action_manager_get_type_once (void);
static void _vala_warble_action_manager_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_warble_action_manager_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const GActionEntry WARBLE_ACTION_MANAGER_ACTION_ENTRIES[3] = {{WARBLE_ACTION_MANAGER_ACTION_NEW_GAME, _warble_action_manager_action_new_game_gsimple_action_activate_callback}, {WARBLE_ACTION_MANAGER_ACTION_HELP, _warble_action_manager_action_help_gsimple_action_activate_callback}, {WARBLE_ACTION_MANAGER_ACTION_QUIT, _warble_action_manager_action_quit_gsimple_action_activate_callback}};

static inline gpointer
warble_action_manager_get_instance_private (WarbleActionManager* self)
{
	return G_STRUCT_MEMBER_P (self, WarbleActionManager_private_offset);
}

static void
_warble_action_manager_action_new_game_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self)
{
	warble_action_manager_action_new_game ((WarbleActionManager*) self);
}

static void
_warble_action_manager_action_help_gsimple_action_activate_callback (GSimpleAction* action,
                                                                     GVariant* parameter,
                                                                     gpointer self)
{
	warble_action_manager_action_help ((WarbleActionManager*) self);
}

static void
_warble_action_manager_action_quit_gsimple_action_activate_callback (GSimpleAction* action,
                                                                     GVariant* parameter,
                                                                     gpointer self)
{
	warble_action_manager_action_quit ((WarbleActionManager*) self);
}

WarbleActionManager*
warble_action_manager_construct (GType object_type,
                                 WarbleApplication* application,
                                 WarbleMainWindow* window)
{
	WarbleActionManager * self = NULL;
	g_return_val_if_fail (application != NULL, NULL);
	g_return_val_if_fail (window != NULL, NULL);
	self = (WarbleActionManager*) g_object_new (object_type, "application", application, "window", window, NULL);
	return self;
}

WarbleActionManager*
warble_action_manager_new (WarbleApplication* application,
                           WarbleMainWindow* window)
{
	return warble_action_manager_construct (WARBLE_TYPE_ACTION_MANAGER, application, window);
}

void
warble_action_manager_action_from_group (const gchar* action_name,
                                         GActionGroup* action_group,
                                         GVariant* parameter)
{
	g_return_if_fail (action_name != NULL);
	g_return_if_fail (action_group != NULL);
	g_action_group_activate_action (action_group, action_name, parameter);
}

static void
warble_action_manager_action_new_game (WarbleActionManager* self)
{
	WarbleMainWindow* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_window;
	warble_main_window_new_game (_tmp0_);
}

static void
warble_action_manager_action_help (WarbleActionManager* self)
{
	WarbleMainWindow* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_window;
	warble_main_window_show_rules (_tmp0_);
}

static void
warble_action_manager_action_quit (WarbleActionManager* self)
{
	WarbleMainWindow* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_window;
	warble_main_window_before_destroy (_tmp0_);
}

WarbleApplication*
warble_action_manager_get_application (WarbleActionManager* self)
{
	WarbleApplication* result;
	WarbleApplication* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_application;
	result = _tmp0_;
	return result;
}

static void
warble_action_manager_set_application (WarbleActionManager* self,
                                       WarbleApplication* value)
{
	WarbleApplication* old_value;
	g_return_if_fail (self != NULL);
	old_value = warble_action_manager_get_application (self);
	if (old_value != value) {
		self->priv->_application = value;
		g_object_notify_by_pspec ((GObject *) self, warble_action_manager_properties[WARBLE_ACTION_MANAGER_APPLICATION_PROPERTY]);
	}
}

WarbleMainWindow*
warble_action_manager_get_window (WarbleActionManager* self)
{
	WarbleMainWindow* result;
	WarbleMainWindow* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_window;
	result = _tmp0_;
	return result;
}

static void
warble_action_manager_set_window (WarbleActionManager* self,
                                  WarbleMainWindow* value)
{
	WarbleMainWindow* old_value;
	g_return_if_fail (self != NULL);
	old_value = warble_action_manager_get_window (self);
	if (old_value != value) {
		self->priv->_window = value;
		g_object_notify_by_pspec ((GObject *) self, warble_action_manager_properties[WARBLE_ACTION_MANAGER_WINDOW_PROPERTY]);
	}
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static GObject *
warble_action_manager_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WarbleActionManager * self;
	GSimpleActionGroup* _tmp0_;
	GSimpleActionGroup* _tmp1_;
	WarbleMainWindow* _tmp2_;
	GSimpleActionGroup* _tmp3_;
	parent_class = G_OBJECT_CLASS (warble_action_manager_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WARBLE_TYPE_ACTION_MANAGER, WarbleActionManager);
	_tmp0_ = g_simple_action_group_new ();
	_g_object_unref0 (self->priv->action_group);
	self->priv->action_group = _tmp0_;
	_tmp1_ = self->priv->action_group;
	g_action_map_add_action_entries ((GActionMap*) _tmp1_, WARBLE_ACTION_MANAGER_ACTION_ENTRIES, (gint) G_N_ELEMENTS (WARBLE_ACTION_MANAGER_ACTION_ENTRIES), self);
	_tmp2_ = self->priv->_window;
	_tmp3_ = self->priv->action_group;
	gtk_widget_insert_action_group ((GtkWidget*) _tmp2_, "win", (GActionGroup*) _tmp3_);
	{
		GeeIterator* _action_it = NULL;
		GeeMultiMap* _tmp4_;
		GeeSet* _tmp5_;
		GeeSet* _tmp6_;
		GeeIterator* _tmp7_;
		GeeIterator* _tmp8_;
		_tmp4_ = warble_action_manager_accelerators;
		_tmp5_ = gee_multi_map_get_keys (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = gee_iterable_iterator ((GeeIterable*) _tmp6_);
		_tmp8_ = _tmp7_;
		_g_object_unref0 (_tmp6_);
		_action_it = _tmp8_;
		while (TRUE) {
			GeeIterator* _tmp9_;
			gchar* action = NULL;
			GeeIterator* _tmp10_;
			gpointer _tmp11_;
			gchar** accelerators_array = NULL;
			GeeMultiMap* _tmp12_;
			const gchar* _tmp13_;
			GeeCollection* _tmp14_;
			GeeCollection* _tmp15_;
			gint _tmp16_ = 0;
			gpointer* _tmp17_;
			gchar** _tmp18_;
			gint _tmp18__length1;
			gint accelerators_array_length1;
			gint _accelerators_array_size_;
			WarbleApplication* _tmp19_;
			const gchar* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			gchar** _tmp23_;
			gint _tmp23__length1;
			_tmp9_ = _action_it;
			if (!gee_iterator_next (_tmp9_)) {
				break;
			}
			_tmp10_ = _action_it;
			_tmp11_ = gee_iterator_get (_tmp10_);
			action = (gchar*) _tmp11_;
			_tmp12_ = warble_action_manager_accelerators;
			_tmp13_ = action;
			_tmp14_ = gee_multi_map_get (_tmp12_, _tmp13_);
			_tmp15_ = _tmp14_;
			_tmp17_ = gee_collection_to_array (_tmp15_, &_tmp16_);
			_tmp18_ = _tmp17_;
			_tmp18__length1 = _tmp16_;
			_g_object_unref0 (_tmp15_);
			accelerators_array = _tmp18_;
			accelerators_array_length1 = _tmp18__length1;
			_accelerators_array_size_ = accelerators_array_length1;
			_vala_array_add1 (&accelerators_array, &accelerators_array_length1, &_accelerators_array_size_, NULL);
			_tmp19_ = self->priv->_application;
			_tmp20_ = action;
			_tmp21_ = g_strconcat (WARBLE_ACTION_MANAGER_ACTION_PREFIX, _tmp20_, NULL);
			_tmp22_ = _tmp21_;
			_tmp23_ = accelerators_array;
			_tmp23__length1 = accelerators_array_length1;
			gtk_application_set_accels_for_action ((GtkApplication*) _tmp19_, _tmp22_, _tmp23_);
			_g_free0 (_tmp22_);
			accelerators_array = (_vala_array_free (accelerators_array, accelerators_array_length1, (GDestroyNotify) g_free), NULL);
			_g_free0 (action);
		}
		_g_object_unref0 (_action_it);
	}
	return obj;
}

static void
warble_action_manager_class_init (WarbleActionManagerClass * klass,
                                  gpointer klass_data)
{
	GeeHashMultiMap* _tmp0_;
	GeeMultiMap* _tmp1_;
	GeeMultiMap* _tmp2_;
	GeeMultiMap* _tmp3_;
	warble_action_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &WarbleActionManager_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_warble_action_manager_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_warble_action_manager_set_property;
	G_OBJECT_CLASS (klass)->constructor = warble_action_manager_constructor;
	G_OBJECT_CLASS (klass)->finalize = warble_action_manager_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), WARBLE_ACTION_MANAGER_APPLICATION_PROPERTY, warble_action_manager_properties[WARBLE_ACTION_MANAGER_APPLICATION_PROPERTY] = g_param_spec_object ("application", "application", "application", WARBLE_TYPE_APPLICATION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WARBLE_ACTION_MANAGER_WINDOW_PROPERTY, warble_action_manager_properties[WARBLE_ACTION_MANAGER_WINDOW_PROPERTY] = g_param_spec_object ("window", "window", "window", WARBLE_TYPE_MAIN_WINDOW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	_tmp0_ = gee_hash_multi_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (warble_action_manager_accelerators);
	warble_action_manager_accelerators = (GeeMultiMap*) _tmp0_;
	_tmp1_ = warble_action_manager_accelerators;
	gee_multi_map_set (_tmp1_, WARBLE_ACTION_MANAGER_ACTION_NEW_GAME, "<Control>n");
	_tmp2_ = warble_action_manager_accelerators;
	gee_multi_map_set (_tmp2_, WARBLE_ACTION_MANAGER_ACTION_HELP, "<Control>h");
	_tmp3_ = warble_action_manager_accelerators;
	gee_multi_map_set (_tmp3_, WARBLE_ACTION_MANAGER_ACTION_QUIT, "<Control>q");
}

static void
warble_action_manager_instance_init (WarbleActionManager * self,
                                     gpointer klass)
{
	self->priv = warble_action_manager_get_instance_private (self);
}

static void
warble_action_manager_finalize (GObject * obj)
{
	WarbleActionManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WARBLE_TYPE_ACTION_MANAGER, WarbleActionManager);
	_g_object_unref0 (self->priv->action_group);
	G_OBJECT_CLASS (warble_action_manager_parent_class)->finalize (obj);
}

static GType
warble_action_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WarbleActionManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) warble_action_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WarbleActionManager), 0, (GInstanceInitFunc) warble_action_manager_instance_init, NULL };
	GType warble_action_manager_type_id;
	warble_action_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "WarbleActionManager", &g_define_type_info, 0);
	WarbleActionManager_private_offset = g_type_add_instance_private (warble_action_manager_type_id, sizeof (WarbleActionManagerPrivate));
	return warble_action_manager_type_id;
}

GType
warble_action_manager_get_type (void)
{
	static volatile gsize warble_action_manager_type_id__volatile = 0;
	if (g_once_init_enter (&warble_action_manager_type_id__volatile)) {
		GType warble_action_manager_type_id;
		warble_action_manager_type_id = warble_action_manager_get_type_once ();
		g_once_init_leave (&warble_action_manager_type_id__volatile, warble_action_manager_type_id);
	}
	return warble_action_manager_type_id__volatile;
}

static void
_vala_warble_action_manager_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	WarbleActionManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WARBLE_TYPE_ACTION_MANAGER, WarbleActionManager);
	switch (property_id) {
		case WARBLE_ACTION_MANAGER_APPLICATION_PROPERTY:
		g_value_set_object (value, warble_action_manager_get_application (self));
		break;
		case WARBLE_ACTION_MANAGER_WINDOW_PROPERTY:
		g_value_set_object (value, warble_action_manager_get_window (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_warble_action_manager_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	WarbleActionManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WARBLE_TYPE_ACTION_MANAGER, WarbleActionManager);
	switch (property_id) {
		case WARBLE_ACTION_MANAGER_APPLICATION_PROPERTY:
		warble_action_manager_set_application (self, g_value_get_object (value));
		break;
		case WARBLE_ACTION_MANAGER_WINDOW_PROPERTY:
		warble_action_manager_set_window (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

