/* Difficulty.c generated by valac 0.54.8, the Vala compiler
 * generated from Difficulty.vala, do not modify */

/*
 * Copyright (c) 2022 Andrew Vojak (https://avojak.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Andrew Vojak <andrew.vojak@gmail.com>
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	WARBLE_MODELS_DIFFICULTY_EASY,
	WARBLE_MODELS_DIFFICULTY_NORMAL,
	WARBLE_MODELS_DIFFICULTY_HARD
} WarbleModelsDifficulty;

#define WARBLE_MODELS_TYPE_DIFFICULTY (warble_models_difficulty_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_type_class_unref0(var) ((var == NULL) ? NULL : (var = (g_type_class_unref (var), NULL)))

VALA_EXTERN GType warble_models_difficulty_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* warble_models_difficulty_get_display_string (WarbleModelsDifficulty self);
VALA_EXTERN gchar* warble_models_difficulty_get_details_markup (WarbleModelsDifficulty self);
VALA_EXTERN gint warble_models_difficulty_get_num_letters (WarbleModelsDifficulty self);
VALA_EXTERN gint warble_models_difficulty_get_num_guesses (WarbleModelsDifficulty self);
VALA_EXTERN gboolean warble_models_difficulty_must_use_clues (WarbleModelsDifficulty self);
VALA_EXTERN gchar* warble_models_difficulty_get_short_name (WarbleModelsDifficulty self);
VALA_EXTERN WarbleModelsDifficulty warble_models_difficulty_get_value_by_short_name (const gchar* short_name);
VALA_EXTERN WarbleModelsDifficulty warble_models_difficulty_get_value_by_name (const gchar* name);

gchar*
warble_models_difficulty_get_display_string (WarbleModelsDifficulty self)
{
	gchar* result = NULL;
	switch (self) {
		case WARBLE_MODELS_DIFFICULTY_EASY:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Easy"));
			result = _tmp0_;
			return result;
		}
		case WARBLE_MODELS_DIFFICULTY_NORMAL:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Normal"));
			result = _tmp1_;
			return result;
		}
		case WARBLE_MODELS_DIFFICULTY_HARD:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("Hard"));
			result = _tmp2_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

gchar*
warble_models_difficulty_get_details_markup (WarbleModelsDifficulty self)
{
	gchar* result = NULL;
	switch (self) {
		case WARBLE_MODELS_DIFFICULTY_EASY:
		{
			gchar* _tmp0_;
			gchar* _tmp1_;
			gchar* _tmp2_;
			gchar* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			_tmp0_ = warble_models_difficulty_get_display_string (self);
			_tmp1_ = _tmp0_;
			_tmp2_ = g_strdup_printf ("%s Difficulty: 5-letter words", _tmp1_);
			_tmp3_ = _tmp2_;
			_tmp4_ = g_strdup (_ (_tmp3_));
			_tmp5_ = _tmp4_;
			_g_free0 (_tmp3_);
			_g_free0 (_tmp1_);
			result = _tmp5_;
			return result;
		}
		case WARBLE_MODELS_DIFFICULTY_NORMAL:
		{
			gchar* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			_tmp6_ = warble_models_difficulty_get_display_string (self);
			_tmp7_ = _tmp6_;
			_tmp8_ = g_strdup_printf ("%s Difficulty: 5-letter words\n" \
"<small>All green and yellow letters must be used in subsequent guesses" \
"</small>", _tmp7_);
			_tmp9_ = _tmp8_;
			_tmp10_ = g_strdup (_ (_tmp9_));
			_tmp11_ = _tmp10_;
			_g_free0 (_tmp9_);
			_g_free0 (_tmp7_);
			result = _tmp11_;
			return result;
		}
		case WARBLE_MODELS_DIFFICULTY_HARD:
		{
			gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			_tmp12_ = warble_models_difficulty_get_display_string (self);
			_tmp13_ = _tmp12_;
			_tmp14_ = g_strdup_printf ("%s Difficulty: 6-letter words\n" \
"<small>All green and yellow letters must be used in subsequent guesses" \
"</small>", _tmp13_);
			_tmp15_ = _tmp14_;
			_tmp16_ = g_strdup (_ (_tmp15_));
			_tmp17_ = _tmp16_;
			_g_free0 (_tmp15_);
			_g_free0 (_tmp13_);
			result = _tmp17_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

gint
warble_models_difficulty_get_num_letters (WarbleModelsDifficulty self)
{
	gint result = 0;
	switch (self) {
		case WARBLE_MODELS_DIFFICULTY_EASY:
		{
			result = 5;
			return result;
		}
		case WARBLE_MODELS_DIFFICULTY_NORMAL:
		{
			result = 5;
			return result;
		}
		case WARBLE_MODELS_DIFFICULTY_HARD:
		{
			result = 6;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

gint
warble_models_difficulty_get_num_guesses (WarbleModelsDifficulty self)
{
	gint result = 0;
	switch (self) {
		case WARBLE_MODELS_DIFFICULTY_EASY:
		{
			result = 6;
			return result;
		}
		case WARBLE_MODELS_DIFFICULTY_NORMAL:
		{
			result = 6;
			return result;
		}
		case WARBLE_MODELS_DIFFICULTY_HARD:
		{
			result = 6;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

gboolean
warble_models_difficulty_must_use_clues (WarbleModelsDifficulty self)
{
	gboolean result = FALSE;
	switch (self) {
		case WARBLE_MODELS_DIFFICULTY_EASY:
		{
			result = FALSE;
			return result;
		}
		case WARBLE_MODELS_DIFFICULTY_NORMAL:
		{
			result = TRUE;
			return result;
		}
		case WARBLE_MODELS_DIFFICULTY_HARD:
		{
			result = TRUE;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

gchar*
warble_models_difficulty_get_short_name (WarbleModelsDifficulty self)
{
	gchar* result = NULL;
	switch (self) {
		case WARBLE_MODELS_DIFFICULTY_EASY:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup ("EASY");
			result = _tmp0_;
			return result;
		}
		case WARBLE_MODELS_DIFFICULTY_NORMAL:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup ("NORMAL");
			result = _tmp1_;
			return result;
		}
		case WARBLE_MODELS_DIFFICULTY_HARD:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup ("HARD");
			result = _tmp2_;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

WarbleModelsDifficulty
warble_models_difficulty_get_value_by_short_name (const gchar* short_name)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
	static GQuark _tmp1_label0 = 0;
	static GQuark _tmp1_label1 = 0;
	static GQuark _tmp1_label2 = 0;
	WarbleModelsDifficulty result = 0;
	g_return_val_if_fail (short_name != NULL, 0);
	_tmp0_ = short_name;
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("EASY")))) {
		switch (0) {
			default:
			{
				result = WARBLE_MODELS_DIFFICULTY_EASY;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("NORMAL")))) {
		switch (0) {
			default:
			{
				result = WARBLE_MODELS_DIFFICULTY_NORMAL;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("HARD")))) {
		switch (0) {
			default:
			{
				result = WARBLE_MODELS_DIFFICULTY_HARD;
				return result;
			}
		}
	} else {
		switch (0) {
			default:
			{
				g_assert_not_reached ();
			}
		}
	}
}

WarbleModelsDifficulty
warble_models_difficulty_get_value_by_name (const gchar* name)
{
	GEnumClass* enumc = NULL;
	GTypeClass* _tmp0_;
	GEnumValue* eval = NULL;
	WarbleModelsDifficulty result = 0;
	g_return_val_if_fail (name != NULL, 0);
	_tmp0_ = g_type_class_ref (WARBLE_MODELS_TYPE_DIFFICULTY);
	enumc = (GEnumClass*) _tmp0_;
	eval = g_enum_get_value_by_name (enumc, name);
	if (eval == NULL) {
		g_assert_not_reached ();
	}
	result = (WarbleModelsDifficulty) (*eval).value;
	_g_type_class_unref0 (enumc);
	return result;
}

static GType
warble_models_difficulty_get_type_once (void)
{
	static const GEnumValue values[] = {{WARBLE_MODELS_DIFFICULTY_EASY, "WARBLE_MODELS_DIFFICULTY_EASY", "easy"}, {WARBLE_MODELS_DIFFICULTY_NORMAL, "WARBLE_MODELS_DIFFICULTY_NORMAL", "normal"}, {WARBLE_MODELS_DIFFICULTY_HARD, "WARBLE_MODELS_DIFFICULTY_HARD", "hard"}, {0, NULL, NULL}};
	GType warble_models_difficulty_type_id;
	warble_models_difficulty_type_id = g_enum_register_static ("WarbleModelsDifficulty", values);
	return warble_models_difficulty_type_id;
}

GType
warble_models_difficulty_get_type (void)
{
	static volatile gsize warble_models_difficulty_type_id__volatile = 0;
	if (g_once_init_enter (&warble_models_difficulty_type_id__volatile)) {
		GType warble_models_difficulty_type_id;
		warble_models_difficulty_type_id = warble_models_difficulty_get_type_once ();
		g_once_init_leave (&warble_models_difficulty_type_id__volatile, warble_models_difficulty_type_id);
	}
	return warble_models_difficulty_type_id__volatile;
}

