/* Key.c generated by valac 0.54.8, the Vala compiler
 * generated from Key.vala, do not modify */

/*
 * Copyright (c) 2022 Andrew Vojak (https://avojak.com)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Andrew Vojak <andrew.vojak@gmail.com>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <cairo-gobject.h>
#include <granite.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>

#define CONSTANTS_APP_ID "com.github.avojak.warble"
#define WARBLE_WIDGETS_KEY_KEY_IMAGE_SIZE 32
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define WARBLE_WIDGETS_TYPE_KEY (warble_widgets_key_get_type ())
#define WARBLE_WIDGETS_KEY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), WARBLE_WIDGETS_TYPE_KEY, WarbleWidgetsKey))
#define WARBLE_WIDGETS_KEY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), WARBLE_WIDGETS_TYPE_KEY, WarbleWidgetsKeyClass))
#define WARBLE_WIDGETS_IS_KEY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WARBLE_WIDGETS_TYPE_KEY))
#define WARBLE_WIDGETS_IS_KEY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WARBLE_WIDGETS_TYPE_KEY))
#define WARBLE_WIDGETS_KEY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), WARBLE_WIDGETS_TYPE_KEY, WarbleWidgetsKeyClass))

typedef struct _WarbleWidgetsKey WarbleWidgetsKey;
typedef struct _WarbleWidgetsKeyClass WarbleWidgetsKeyClass;
typedef struct _WarbleWidgetsKeyPrivate WarbleWidgetsKeyPrivate;
typedef enum  {
	WARBLE_MODELS_STATE_BLANK,
	WARBLE_MODELS_STATE_CORRECT,
	WARBLE_MODELS_STATE_INCORRECT,
	WARBLE_MODELS_STATE_CLOSE
} WarbleModelsState;

#define WARBLE_MODELS_TYPE_STATE (warble_models_state_get_type ())

#define WARBLE_WIDGETS_KEY_TYPE_KEY_IMAGE (warble_widgets_key_key_image_get_type ())
#define WARBLE_WIDGETS_KEY_KEY_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), WARBLE_WIDGETS_KEY_TYPE_KEY_IMAGE, WarbleWidgetsKeyKeyImage))
#define WARBLE_WIDGETS_KEY_KEY_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), WARBLE_WIDGETS_KEY_TYPE_KEY_IMAGE, WarbleWidgetsKeyKeyImageClass))
#define WARBLE_WIDGETS_KEY_IS_KEY_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WARBLE_WIDGETS_KEY_TYPE_KEY_IMAGE))
#define WARBLE_WIDGETS_KEY_IS_KEY_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WARBLE_WIDGETS_KEY_TYPE_KEY_IMAGE))
#define WARBLE_WIDGETS_KEY_KEY_IMAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), WARBLE_WIDGETS_KEY_TYPE_KEY_IMAGE, WarbleWidgetsKeyKeyImageClass))

typedef struct _WarbleWidgetsKeyKeyImage WarbleWidgetsKeyKeyImage;
typedef struct _WarbleWidgetsKeyKeyImageClass WarbleWidgetsKeyKeyImageClass;
enum  {
	WARBLE_WIDGETS_KEY_0_PROPERTY,
	WARBLE_WIDGETS_KEY_LETTER_PROPERTY,
	WARBLE_WIDGETS_KEY_STATE_PROPERTY,
	WARBLE_WIDGETS_KEY_NUM_PROPERTIES
};
static GParamSpec* warble_widgets_key_properties[WARBLE_WIDGETS_KEY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _WarbleWidgetsKeyKeyImagePrivate WarbleWidgetsKeyKeyImagePrivate;
enum  {
	WARBLE_WIDGETS_KEY_KEY_IMAGE_0_PROPERTY,
	WARBLE_WIDGETS_KEY_KEY_IMAGE_LETTER_PROPERTY,
	WARBLE_WIDGETS_KEY_KEY_IMAGE_Y_OFFSET_PROPERTY,
	WARBLE_WIDGETS_KEY_KEY_IMAGE_NUM_PROPERTIES
};
static GParamSpec* warble_widgets_key_key_image_properties[WARBLE_WIDGETS_KEY_KEY_IMAGE_NUM_PROPERTIES];
typedef enum  {
	WARBLE_COLOR_PALETTE_TEXT_COLOR
} WarbleColorPalette;

#define WARBLE_TYPE_COLOR_PALETTE (warble_color_palette_get_type ())
enum  {
	WARBLE_WIDGETS_KEY_CLICKED_SIGNAL,
	WARBLE_WIDGETS_KEY_NUM_SIGNALS
};
static guint warble_widgets_key_signals[WARBLE_WIDGETS_KEY_NUM_SIGNALS] = {0};

struct _WarbleWidgetsKey {
	GtkEventBox parent_instance;
	WarbleWidgetsKeyPrivate * priv;
};

struct _WarbleWidgetsKeyClass {
	GtkEventBoxClass parent_class;
};

struct _WarbleWidgetsKeyPrivate {
	gchar _letter;
	WarbleModelsState _state;
	WarbleWidgetsKeyKeyImage* key;
	gboolean is_pressed;
};

struct _WarbleWidgetsKeyKeyImage {
	GtkImage parent_instance;
	WarbleWidgetsKeyKeyImagePrivate * priv;
};

struct _WarbleWidgetsKeyKeyImageClass {
	GtkImageClass parent_class;
};

struct _WarbleWidgetsKeyKeyImagePrivate {
	gchar _letter;
	gint _y_offset;
};

static gint WarbleWidgetsKey_private_offset;
static gpointer warble_widgets_key_parent_class = NULL;
VALA_EXTERN GSettings* warble_application_settings;
static gint WarbleWidgetsKeyKeyImage_private_offset;
static gpointer warble_widgets_key_key_image_parent_class = NULL;

VALA_EXTERN GType warble_widgets_key_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WarbleWidgetsKey, g_object_unref)
VALA_EXTERN GType warble_models_state_get_type (void) G_GNUC_CONST ;
static GType warble_widgets_key_key_image_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WarbleWidgetsKeyKeyImage, g_object_unref)
VALA_EXTERN WarbleWidgetsKey* warble_widgets_key_new (gchar letter);
VALA_EXTERN WarbleWidgetsKey* warble_widgets_key_construct (GType object_type,
                                                gchar letter);
static void warble_widgets_key_update_icon (WarbleWidgetsKey* self);
VALA_EXTERN WarbleModelsState warble_widgets_key_get_state (WarbleWidgetsKey* self);
VALA_EXTERN gchar warble_widgets_key_get_letter (WarbleWidgetsKey* self);
static void warble_widgets_key_set_letter (WarbleWidgetsKey* self,
                                    gchar value);
VALA_EXTERN void warble_widgets_key_set_state (WarbleWidgetsKey* self,
                                   WarbleModelsState value);
static WarbleWidgetsKeyKeyImage* warble_widgets_key_key_image_new (gchar letter);
static WarbleWidgetsKeyKeyImage* warble_widgets_key_key_image_construct (GType object_type,
                                                                  gchar letter);
static gboolean warble_widgets_key_key_image_real_draw (GtkWidget* base,
                                                 cairo_t* ctx);
static void warble_widgets_key_key_image_draw_letter (WarbleWidgetsKeyKeyImage* self,
                                               cairo_t* ctx);
VALA_EXTERN GType warble_color_palette_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* warble_color_palette_get_value (WarbleColorPalette self);
static gchar warble_widgets_key_key_image_get_letter (WarbleWidgetsKeyKeyImage* self);
static gint warble_widgets_key_key_image_get_y_offset (WarbleWidgetsKeyKeyImage* self);
static void warble_widgets_key_key_image_set_letter (WarbleWidgetsKeyKeyImage* self,
                                              gchar value);
static void warble_widgets_key_key_image_set_y_offset (WarbleWidgetsKeyKeyImage* self,
                                                gint value);
static void warble_widgets_key_key_image_finalize (GObject * obj);
static GType warble_widgets_key_key_image_get_type_once (void);
static void _vala_warble_widgets_key_key_image_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec);
static void _vala_warble_widgets_key_key_image_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec);
static GObject * warble_widgets_key_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static gboolean _warble_widgets_key___lambda15_ (WarbleWidgetsKey* self,
                                          GdkEventButton* event);
static gboolean __warble_widgets_key___lambda15__gtk_widget_button_press_event (GtkWidget* _sender,
                                                                         GdkEventButton* event,
                                                                         gpointer self);
static gboolean _warble_widgets_key___lambda16_ (WarbleWidgetsKey* self);
static gboolean __warble_widgets_key___lambda16__gtk_widget_button_release_event (GtkWidget* _sender,
                                                                           GdkEventButton* event,
                                                                           gpointer self);
static gboolean _warble_widgets_key___lambda17_ (WarbleWidgetsKey* self);
static gboolean __warble_widgets_key___lambda17__gtk_widget_touch_event (GtkWidget* _sender,
                                                                  GdkEvent* event,
                                                                  gpointer self);
static void _warble_widgets_key___lambda18_ (WarbleWidgetsKey* self,
                                      const gchar* key);
static void __warble_widgets_key___lambda18__g_settings_changed (GSettings* _sender,
                                                          const gchar* key,
                                                          gpointer self);
static void warble_widgets_key_finalize (GObject * obj);
static GType warble_widgets_key_get_type_once (void);
static void _vala_warble_widgets_key_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_warble_widgets_key_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);

static inline gpointer
warble_widgets_key_get_instance_private (WarbleWidgetsKey* self)
{
	return G_STRUCT_MEMBER_P (self, WarbleWidgetsKey_private_offset);
}

WarbleWidgetsKey*
warble_widgets_key_construct (GType object_type,
                              gchar letter)
{
	WarbleWidgetsKey * self = NULL;
	self = (WarbleWidgetsKey*) g_object_new (object_type, "letter", letter, NULL);
	return self;
}

WarbleWidgetsKey*
warble_widgets_key_new (gchar letter)
{
	return warble_widgets_key_construct (WARBLE_WIDGETS_TYPE_KEY, letter);
}

static void
warble_widgets_key_update_icon (WarbleWidgetsKey* self)
{
	gboolean high_contrast_mode = FALSE;
	GSettings* _tmp0_;
	WarbleModelsState _tmp1_;
	WarbleModelsState _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = warble_application_settings;
	high_contrast_mode = g_settings_get_boolean (_tmp0_, "high-contrast-mode");
	_tmp1_ = warble_widgets_key_get_state (self);
	_tmp2_ = _tmp1_;
	switch (_tmp2_) {
		case WARBLE_MODELS_STATE_BLANK:
		{
			const gchar* _tmp3_ = NULL;
			WarbleWidgetsKeyKeyImage* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			GThemedIcon* _tmp7_;
			GThemedIcon* _tmp8_;
			if (self->priv->is_pressed) {
				_tmp3_ = ".key-pressed-blank";
			} else {
				_tmp3_ = ".key-blank";
			}
			_tmp4_ = self->priv->key;
			_tmp5_ = g_strconcat (CONSTANTS_APP_ID, _tmp3_, NULL);
			_tmp6_ = _tmp5_;
			_tmp7_ = (GThemedIcon*) g_themed_icon_new (_tmp6_);
			_tmp8_ = _tmp7_;
			g_object_set ((GtkImage*) _tmp4_, "gicon", (GIcon*) _tmp8_, NULL);
			_g_object_unref0 (_tmp8_);
			_g_free0 (_tmp6_);
			break;
		}
		case WARBLE_MODELS_STATE_INCORRECT:
		{
			const gchar* _tmp9_ = NULL;
			WarbleWidgetsKeyKeyImage* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			GThemedIcon* _tmp13_;
			GThemedIcon* _tmp14_;
			if (self->priv->is_pressed) {
				_tmp9_ = ".key-pressed-incorrect";
			} else {
				_tmp9_ = ".key-incorrect";
			}
			_tmp10_ = self->priv->key;
			_tmp11_ = g_strconcat (CONSTANTS_APP_ID, _tmp9_, NULL);
			_tmp12_ = _tmp11_;
			_tmp13_ = (GThemedIcon*) g_themed_icon_new (_tmp12_);
			_tmp14_ = _tmp13_;
			g_object_set ((GtkImage*) _tmp10_, "gicon", (GIcon*) _tmp14_, NULL);
			_g_object_unref0 (_tmp14_);
			_g_free0 (_tmp12_);
			break;
		}
		case WARBLE_MODELS_STATE_CLOSE:
		{
			const gchar* _tmp15_ = NULL;
			const gchar* _tmp16_ = NULL;
			WarbleWidgetsKeyKeyImage* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
			GThemedIcon* _tmp22_;
			GThemedIcon* _tmp23_;
			if (self->priv->is_pressed) {
				_tmp15_ = ".key-pressed-close";
			} else {
				_tmp15_ = ".key-close";
			}
			if (high_contrast_mode) {
				_tmp16_ = "-high-contrast";
			} else {
				_tmp16_ = "";
			}
			_tmp17_ = self->priv->key;
			_tmp18_ = g_strconcat (CONSTANTS_APP_ID, _tmp15_, NULL);
			_tmp19_ = _tmp18_;
			_tmp20_ = g_strconcat (_tmp19_, _tmp16_, NULL);
			_tmp21_ = _tmp20_;
			_tmp22_ = (GThemedIcon*) g_themed_icon_new (_tmp21_);
			_tmp23_ = _tmp22_;
			g_object_set ((GtkImage*) _tmp17_, "gicon", (GIcon*) _tmp23_, NULL);
			_g_object_unref0 (_tmp23_);
			_g_free0 (_tmp21_);
			_g_free0 (_tmp19_);
			break;
		}
		case WARBLE_MODELS_STATE_CORRECT:
		{
			const gchar* _tmp24_ = NULL;
			const gchar* _tmp25_ = NULL;
			WarbleWidgetsKeyKeyImage* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			gchar* _tmp30_;
			GThemedIcon* _tmp31_;
			GThemedIcon* _tmp32_;
			if (self->priv->is_pressed) {
				_tmp24_ = ".key-pressed-correct";
			} else {
				_tmp24_ = ".key-correct";
			}
			if (high_contrast_mode) {
				_tmp25_ = "-high-contrast";
			} else {
				_tmp25_ = "";
			}
			_tmp26_ = self->priv->key;
			_tmp27_ = g_strconcat (CONSTANTS_APP_ID, _tmp24_, NULL);
			_tmp28_ = _tmp27_;
			_tmp29_ = g_strconcat (_tmp28_, _tmp25_, NULL);
			_tmp30_ = _tmp29_;
			_tmp31_ = (GThemedIcon*) g_themed_icon_new (_tmp30_);
			_tmp32_ = _tmp31_;
			g_object_set ((GtkImage*) _tmp26_, "gicon", (GIcon*) _tmp32_, NULL);
			_g_object_unref0 (_tmp32_);
			_g_free0 (_tmp30_);
			_g_free0 (_tmp28_);
			break;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

gchar
warble_widgets_key_get_letter (WarbleWidgetsKey* self)
{
	gchar result;
	g_return_val_if_fail (self != NULL, '\0');
	result = self->priv->_letter;
	return result;
}

static void
warble_widgets_key_set_letter (WarbleWidgetsKey* self,
                               gchar value)
{
	gchar old_value;
	g_return_if_fail (self != NULL);
	old_value = warble_widgets_key_get_letter (self);
	if (old_value != value) {
		self->priv->_letter = value;
		g_object_notify_by_pspec ((GObject *) self, warble_widgets_key_properties[WARBLE_WIDGETS_KEY_LETTER_PROPERTY]);
	}
}

WarbleModelsState
warble_widgets_key_get_state (WarbleWidgetsKey* self)
{
	WarbleModelsState result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_state;
	return result;
}

void
warble_widgets_key_set_state (WarbleWidgetsKey* self,
                              WarbleModelsState value)
{
	g_return_if_fail (self != NULL);
	self->priv->_state = value;
	warble_widgets_key_update_icon (self);
	g_object_notify_by_pspec ((GObject *) self, warble_widgets_key_properties[WARBLE_WIDGETS_KEY_STATE_PROPERTY]);
}

static inline gpointer
warble_widgets_key_key_image_get_instance_private (WarbleWidgetsKeyKeyImage* self)
{
	return G_STRUCT_MEMBER_P (self, WarbleWidgetsKeyKeyImage_private_offset);
}

static WarbleWidgetsKeyKeyImage*
warble_widgets_key_key_image_construct (GType object_type,
                                        gchar letter)
{
	WarbleWidgetsKeyKeyImage * self = NULL;
	GThemedIcon* _tmp0_;
	GThemedIcon* _tmp1_;
	_tmp0_ = (GThemedIcon*) g_themed_icon_new (CONSTANTS_APP_ID ".key-blank");
	_tmp1_ = _tmp0_;
	self = (WarbleWidgetsKeyKeyImage*) g_object_new (object_type, "gicon", _tmp1_, "pixel-size", WARBLE_WIDGETS_KEY_KEY_IMAGE_SIZE, "letter", letter, "y-offset", 0, "expand", FALSE, "halign", GTK_ALIGN_CENTER, NULL);
	_g_object_unref0 (_tmp1_);
	return self;
}

static WarbleWidgetsKeyKeyImage*
warble_widgets_key_key_image_new (gchar letter)
{
	return warble_widgets_key_key_image_construct (WARBLE_WIDGETS_KEY_TYPE_KEY_IMAGE, letter);
}

static gboolean
warble_widgets_key_key_image_real_draw (GtkWidget* base,
                                        cairo_t* ctx)
{
	WarbleWidgetsKeyKeyImage * self;
	gboolean result = FALSE;
	self = (WarbleWidgetsKeyKeyImage*) base;
	g_return_val_if_fail (ctx != NULL, FALSE);
	GTK_WIDGET_CLASS (warble_widgets_key_key_image_parent_class)->draw ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_image_get_type (), GtkImage), ctx);
	cairo_save (ctx);
	warble_widgets_key_key_image_draw_letter (self, ctx);
	cairo_restore (ctx);
	result = FALSE;
	return result;
}

static void
warble_widgets_key_key_image_draw_letter (WarbleWidgetsKeyKeyImage* self,
                                          cairo_t* ctx)
{
	GraniteDrawingColor* color = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GraniteDrawingColor* _tmp2_;
	GraniteDrawingColor* _tmp3_;
	cairo_text_extents_t extents = {0};
	gchar _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	cairo_text_extents_t _tmp7_ = {0};
	gdouble x = 0.0;
	cairo_text_extents_t _tmp8_;
	cairo_text_extents_t _tmp9_;
	gdouble y = 0.0;
	cairo_text_extents_t _tmp10_;
	cairo_text_extents_t _tmp11_;
	gint _tmp12_;
	gchar _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (ctx != NULL);
	_tmp0_ = warble_color_palette_get_value (WARBLE_COLOR_PALETTE_TEXT_COLOR);
	_tmp1_ = _tmp0_;
	_tmp2_ = granite_drawing_color_new_from_string (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_free0 (_tmp1_);
	color = _tmp3_;
	cairo_set_source_rgb (ctx, color->R, color->G, color->B);
	cairo_select_font_face (ctx, "Inter", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_BOLD);
	cairo_set_font_size (ctx, (gdouble) 15);
	_tmp4_ = self->priv->_letter;
	_tmp5_ = g_strdup_printf ("%c", _tmp4_);
	_tmp6_ = _tmp5_;
	cairo_text_extents (ctx, _tmp6_, &_tmp7_);
	extents = _tmp7_;
	_g_free0 (_tmp6_);
	_tmp8_ = extents;
	_tmp9_ = extents;
	x = (WARBLE_WIDGETS_KEY_KEY_IMAGE_SIZE / 2) - ((_tmp8_.width / 2) + _tmp9_.x_bearing);
	_tmp10_ = extents;
	_tmp11_ = extents;
	_tmp12_ = self->priv->_y_offset;
	y = ((WARBLE_WIDGETS_KEY_KEY_IMAGE_SIZE / 2) - ((_tmp10_.height / 2) + _tmp11_.y_bearing)) + _tmp12_;
	cairo_move_to (ctx, x, y);
	_tmp13_ = self->priv->_letter;
	_tmp14_ = g_strdup_printf ("%c", _tmp13_);
	_tmp15_ = _tmp14_;
	cairo_show_text (ctx, _tmp15_);
	_g_free0 (_tmp15_);
	_g_object_unref0 (color);
}

static gchar
warble_widgets_key_key_image_get_letter (WarbleWidgetsKeyKeyImage* self)
{
	gchar result;
	g_return_val_if_fail (self != NULL, '\0');
	result = self->priv->_letter;
	return result;
}

static void
warble_widgets_key_key_image_set_letter (WarbleWidgetsKeyKeyImage* self,
                                         gchar value)
{
	gchar old_value;
	g_return_if_fail (self != NULL);
	old_value = warble_widgets_key_key_image_get_letter (self);
	if (old_value != value) {
		self->priv->_letter = value;
		g_object_notify_by_pspec ((GObject *) self, warble_widgets_key_key_image_properties[WARBLE_WIDGETS_KEY_KEY_IMAGE_LETTER_PROPERTY]);
	}
}

static gint
warble_widgets_key_key_image_get_y_offset (WarbleWidgetsKeyKeyImage* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_y_offset;
	return result;
}

static void
warble_widgets_key_key_image_set_y_offset (WarbleWidgetsKeyKeyImage* self,
                                           gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = warble_widgets_key_key_image_get_y_offset (self);
	if (old_value != value) {
		self->priv->_y_offset = value;
		g_object_notify_by_pspec ((GObject *) self, warble_widgets_key_key_image_properties[WARBLE_WIDGETS_KEY_KEY_IMAGE_Y_OFFSET_PROPERTY]);
	}
}

static void
warble_widgets_key_key_image_class_init (WarbleWidgetsKeyKeyImageClass * klass,
                                         gpointer klass_data)
{
	warble_widgets_key_key_image_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &WarbleWidgetsKeyKeyImage_private_offset);
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) warble_widgets_key_key_image_real_draw;
	G_OBJECT_CLASS (klass)->get_property = _vala_warble_widgets_key_key_image_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_warble_widgets_key_key_image_set_property;
	G_OBJECT_CLASS (klass)->finalize = warble_widgets_key_key_image_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), WARBLE_WIDGETS_KEY_KEY_IMAGE_LETTER_PROPERTY, warble_widgets_key_key_image_properties[WARBLE_WIDGETS_KEY_KEY_IMAGE_LETTER_PROPERTY] = g_param_spec_char ("letter", "letter", "letter", G_MININT8, G_MAXINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WARBLE_WIDGETS_KEY_KEY_IMAGE_Y_OFFSET_PROPERTY, warble_widgets_key_key_image_properties[WARBLE_WIDGETS_KEY_KEY_IMAGE_Y_OFFSET_PROPERTY] = g_param_spec_int ("y-offset", "y-offset", "y-offset", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
warble_widgets_key_key_image_instance_init (WarbleWidgetsKeyKeyImage * self,
                                            gpointer klass)
{
	self->priv = warble_widgets_key_key_image_get_instance_private (self);
}

static void
warble_widgets_key_key_image_finalize (GObject * obj)
{
	WarbleWidgetsKeyKeyImage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WARBLE_WIDGETS_KEY_TYPE_KEY_IMAGE, WarbleWidgetsKeyKeyImage);
	G_OBJECT_CLASS (warble_widgets_key_key_image_parent_class)->finalize (obj);
}

static GType
warble_widgets_key_key_image_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WarbleWidgetsKeyKeyImageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) warble_widgets_key_key_image_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WarbleWidgetsKeyKeyImage), 0, (GInstanceInitFunc) warble_widgets_key_key_image_instance_init, NULL };
	GType warble_widgets_key_key_image_type_id;
	warble_widgets_key_key_image_type_id = g_type_register_static (gtk_image_get_type (), "WarbleWidgetsKeyKeyImage", &g_define_type_info, 0);
	WarbleWidgetsKeyKeyImage_private_offset = g_type_add_instance_private (warble_widgets_key_key_image_type_id, sizeof (WarbleWidgetsKeyKeyImagePrivate));
	return warble_widgets_key_key_image_type_id;
}

static GType
warble_widgets_key_key_image_get_type (void)
{
	static volatile gsize warble_widgets_key_key_image_type_id__volatile = 0;
	if (g_once_init_enter (&warble_widgets_key_key_image_type_id__volatile)) {
		GType warble_widgets_key_key_image_type_id;
		warble_widgets_key_key_image_type_id = warble_widgets_key_key_image_get_type_once ();
		g_once_init_leave (&warble_widgets_key_key_image_type_id__volatile, warble_widgets_key_key_image_type_id);
	}
	return warble_widgets_key_key_image_type_id__volatile;
}

static void
_vala_warble_widgets_key_key_image_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec)
{
	WarbleWidgetsKeyKeyImage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WARBLE_WIDGETS_KEY_TYPE_KEY_IMAGE, WarbleWidgetsKeyKeyImage);
	switch (property_id) {
		case WARBLE_WIDGETS_KEY_KEY_IMAGE_LETTER_PROPERTY:
		g_value_set_schar (value, warble_widgets_key_key_image_get_letter (self));
		break;
		case WARBLE_WIDGETS_KEY_KEY_IMAGE_Y_OFFSET_PROPERTY:
		g_value_set_int (value, warble_widgets_key_key_image_get_y_offset (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_warble_widgets_key_key_image_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec)
{
	WarbleWidgetsKeyKeyImage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WARBLE_WIDGETS_KEY_TYPE_KEY_IMAGE, WarbleWidgetsKeyKeyImage);
	switch (property_id) {
		case WARBLE_WIDGETS_KEY_KEY_IMAGE_LETTER_PROPERTY:
		warble_widgets_key_key_image_set_letter (self, g_value_get_schar (value));
		break;
		case WARBLE_WIDGETS_KEY_KEY_IMAGE_Y_OFFSET_PROPERTY:
		warble_widgets_key_key_image_set_y_offset (self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static gboolean
_warble_widgets_key___lambda15_ (WarbleWidgetsKey* self,
                                 GdkEventButton* event)
{
	WarbleWidgetsKeyKeyImage* _tmp0_;
	gchar _tmp1_;
	gboolean result = FALSE;
	g_return_val_if_fail (event != NULL, FALSE);
	if (event->type != GDK_BUTTON_PRESS) {
		result = FALSE;
		return result;
	}
	self->priv->is_pressed = TRUE;
	_tmp0_ = self->priv->key;
	warble_widgets_key_key_image_set_y_offset (_tmp0_, 2);
	warble_widgets_key_update_icon (self);
	_tmp1_ = self->priv->_letter;
	g_signal_emit (self, warble_widgets_key_signals[WARBLE_WIDGETS_KEY_CLICKED_SIGNAL], 0, _tmp1_);
}

static gboolean
__warble_widgets_key___lambda15__gtk_widget_button_press_event (GtkWidget* _sender,
                                                                GdkEventButton* event,
                                                                gpointer self)
{
	gboolean result;
	result = _warble_widgets_key___lambda15_ ((WarbleWidgetsKey*) self, event);
	return result;
}

static gboolean
_warble_widgets_key___lambda16_ (WarbleWidgetsKey* self)
{
	WarbleWidgetsKeyKeyImage* _tmp0_;
	self->priv->is_pressed = FALSE;
	_tmp0_ = self->priv->key;
	warble_widgets_key_key_image_set_y_offset (_tmp0_, 0);
	warble_widgets_key_update_icon (self);
}

static gboolean
__warble_widgets_key___lambda16__gtk_widget_button_release_event (GtkWidget* _sender,
                                                                  GdkEventButton* event,
                                                                  gpointer self)
{
	gboolean result;
	result = _warble_widgets_key___lambda16_ ((WarbleWidgetsKey*) self);
	return result;
}

static gboolean
_warble_widgets_key___lambda17_ (WarbleWidgetsKey* self)
{
	gchar _tmp0_;
	_tmp0_ = self->priv->_letter;
	g_signal_emit (self, warble_widgets_key_signals[WARBLE_WIDGETS_KEY_CLICKED_SIGNAL], 0, _tmp0_);
}

static gboolean
__warble_widgets_key___lambda17__gtk_widget_touch_event (GtkWidget* _sender,
                                                         GdkEvent* event,
                                                         gpointer self)
{
	gboolean result;
	result = _warble_widgets_key___lambda17_ ((WarbleWidgetsKey*) self);
	return result;
}

static void
_warble_widgets_key___lambda18_ (WarbleWidgetsKey* self,
                                 const gchar* key)
{
	g_return_if_fail (key != NULL);
	if (g_strcmp0 (key, "high-contrast-mode") == 0) {
		warble_widgets_key_update_icon (self);
	}
}

static void
__warble_widgets_key___lambda18__g_settings_changed (GSettings* _sender,
                                                     const gchar* key,
                                                     gpointer self)
{
	_warble_widgets_key___lambda18_ ((WarbleWidgetsKey*) self, key);
}

static GObject *
warble_widgets_key_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WarbleWidgetsKey * self;
	gchar _tmp0_;
	WarbleWidgetsKeyKeyImage* _tmp1_;
	WarbleWidgetsKeyKeyImage* _tmp2_;
	GSettings* _tmp3_;
	parent_class = G_OBJECT_CLASS (warble_widgets_key_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WARBLE_WIDGETS_TYPE_KEY, WarbleWidgetsKey);
	_tmp0_ = self->priv->_letter;
	_tmp1_ = warble_widgets_key_key_image_new (_tmp0_);
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->key);
	self->priv->key = _tmp1_;
	_tmp2_ = self->priv->key;
	g_object_set ((GtkContainer*) self, "child", (GtkWidget*) _tmp2_, NULL);
	gtk_widget_add_events ((GtkWidget*) self, (gint) ((GDK_BUTTON_PRESS_MASK | GDK_TOUCH_MASK) | GDK_BUTTON_RELEASE_MASK));
	g_signal_connect_object ((GtkWidget*) self, "button-press-event", (GCallback) __warble_widgets_key___lambda15__gtk_widget_button_press_event, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "button-release-event", (GCallback) __warble_widgets_key___lambda16__gtk_widget_button_release_event, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "touch-event", (GCallback) __warble_widgets_key___lambda17__gtk_widget_touch_event, self, 0);
	_tmp3_ = warble_application_settings;
	g_signal_connect_object (_tmp3_, "changed", (GCallback) __warble_widgets_key___lambda18__g_settings_changed, self, 0);
	return obj;
}

static void
warble_widgets_key_class_init (WarbleWidgetsKeyClass * klass,
                               gpointer klass_data)
{
	warble_widgets_key_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &WarbleWidgetsKey_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_warble_widgets_key_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_warble_widgets_key_set_property;
	G_OBJECT_CLASS (klass)->constructor = warble_widgets_key_constructor;
	G_OBJECT_CLASS (klass)->finalize = warble_widgets_key_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), WARBLE_WIDGETS_KEY_LETTER_PROPERTY, warble_widgets_key_properties[WARBLE_WIDGETS_KEY_LETTER_PROPERTY] = g_param_spec_char ("letter", "letter", "letter", G_MININT8, G_MAXINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WARBLE_WIDGETS_KEY_STATE_PROPERTY, warble_widgets_key_properties[WARBLE_WIDGETS_KEY_STATE_PROPERTY] = g_param_spec_enum ("state", "state", "state", WARBLE_MODELS_TYPE_STATE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	warble_widgets_key_signals[WARBLE_WIDGETS_KEY_CLICKED_SIGNAL] = g_signal_new ("clicked", WARBLE_WIDGETS_TYPE_KEY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__CHAR, G_TYPE_NONE, 1, G_TYPE_CHAR);
}

static void
warble_widgets_key_instance_init (WarbleWidgetsKey * self,
                                  gpointer klass)
{
	self->priv = warble_widgets_key_get_instance_private (self);
	self->priv->_state = WARBLE_MODELS_STATE_BLANK;
	self->priv->is_pressed = FALSE;
}

static void
warble_widgets_key_finalize (GObject * obj)
{
	WarbleWidgetsKey * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WARBLE_WIDGETS_TYPE_KEY, WarbleWidgetsKey);
	_g_object_unref0 (self->priv->key);
	G_OBJECT_CLASS (warble_widgets_key_parent_class)->finalize (obj);
}

static GType
warble_widgets_key_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WarbleWidgetsKeyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) warble_widgets_key_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WarbleWidgetsKey), 0, (GInstanceInitFunc) warble_widgets_key_instance_init, NULL };
	GType warble_widgets_key_type_id;
	warble_widgets_key_type_id = g_type_register_static (gtk_event_box_get_type (), "WarbleWidgetsKey", &g_define_type_info, 0);
	WarbleWidgetsKey_private_offset = g_type_add_instance_private (warble_widgets_key_type_id, sizeof (WarbleWidgetsKeyPrivate));
	return warble_widgets_key_type_id;
}

GType
warble_widgets_key_get_type (void)
{
	static volatile gsize warble_widgets_key_type_id__volatile = 0;
	if (g_once_init_enter (&warble_widgets_key_type_id__volatile)) {
		GType warble_widgets_key_type_id;
		warble_widgets_key_type_id = warble_widgets_key_get_type_once ();
		g_once_init_leave (&warble_widgets_key_type_id__volatile, warble_widgets_key_type_id);
	}
	return warble_widgets_key_type_id__volatile;
}

static void
_vala_warble_widgets_key_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	WarbleWidgetsKey * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WARBLE_WIDGETS_TYPE_KEY, WarbleWidgetsKey);
	switch (property_id) {
		case WARBLE_WIDGETS_KEY_LETTER_PROPERTY:
		g_value_set_schar (value, warble_widgets_key_get_letter (self));
		break;
		case WARBLE_WIDGETS_KEY_STATE_PROPERTY:
		g_value_set_enum (value, warble_widgets_key_get_state (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_warble_widgets_key_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	WarbleWidgetsKey * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WARBLE_WIDGETS_TYPE_KEY, WarbleWidgetsKey);
	switch (property_id) {
		case WARBLE_WIDGETS_KEY_LETTER_PROPERTY:
		warble_widgets_key_set_letter (self, g_value_get_schar (value));
		break;
		case WARBLE_WIDGETS_KEY_STATE_PROPERTY:
		warble_widgets_key_set_state (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

